﻿Imports System.IO

Public Class Form1
    '通信,ファイル関連の変数
    Public ComPort As Integer
    Public nlReceive, nlTransmit As String
    Public TerminalError As Boolean
    Public DataKensuu As Integer
    Public DataReceiveZenkai As Integer
    Public DataReceiveKonkai As Integer
    Public CtrRead As Boolean
    Private Delegate Sub AppendLineDelegate(ByVal line_editbuff1 As String)
    Private fileFilter As String = "データログ温湿度計用連携ツールログデータ|*.csv|すべてのファイル|*.*"
    Private currentFileName As String
    Private title As String = "データログ温湿度計用連携ツール"
    Public FileName As String = "新規ログデータ"
    Private newFileName As String = "新規ログデータ"
    'DATAファイルの変数
    Private datPath As String = My.Application.Info.DirectoryPath & "\THERMOHYGROLOGGER.dat"   'THERMOHYGROLOGGER.exe内フォルダ
    Public dat(105) As String
    'ログファイルの変数
    Private logPath As String = My.Application.Info.DirectoryPath & "\THERMOHYGROLOGGER.log"   'THERMOHYGROLOGGER.exe内フォルダ
    Public year_dat(100000), month_dat(100000), day_dat(100000), hour_dat(100000), min_dat(100000) As Integer   'ログバッファMAX10万件
    Public temp_dat(100000), hr_dat(100000) As Single 'ログバッファMAX10万件
    Public logbufMAXKensuu As Integer
    Public logdat_num, logdat_num_dispbak As Integer
    'ヘルプ用の変数
    Private helpFileName As String = "THERMOHYGROLOGGER.html"

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'ログバッファMAX件数
        logbufMAXKensuu = 100000
        'DATAファイル初期内容
        dat(0) = "0"    '通信設定(初期値)
        'DATAファイルの読み込み
        Try
            Dim fs As New FileStream(datPath, FileMode.OpenOrCreate)
            fs.Close()
        Catch ex As Exception
            MessageBox.Show("DATAファイルが作成できません。", "注意", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Me.Close()
        End Try
        Dim line As String
        Dim num01 As Integer
        Using reader As StreamReader = New StreamReader(datPath, System.Text.Encoding.Default)
            num01 = 0
            Do
                line = reader.ReadLine
                If Not line Is Nothing Then
                    dat(num01) = ""
                    dat(num01) = line
                    num01 = num01 + 1
                End If
            Loop Until reader.Peek = -1 Or num01 = 2
        End Using
        '
        ComPort = dat(0)
        '
        mnuToolLogRead1.Enabled = False
        mnuToolLogRead2.Enabled = False
        mnuToolLogRead3.Enabled = False
        mnuToolEEPROMErase.Enabled = False
        '
        ToolStripStatusLabel1.Text = "ログデータ読み込み中"
        ToolStripStatusLabel2.Text = ""
        '
        Initialise_Timer1.Enabled = True
    End Sub

    Private Sub Initialise_Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Initialise_Timer1.Tick
        Initialise_Timer1.Enabled = False
        'ログファイルの読み込み
        Try
            Dim fs As New FileStream(logPath, FileMode.OpenOrCreate)
            fs.Close()
        Catch ex As Exception
            MessageBox.Show("ログファイルが作成できません。", "注意", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Me.Close()
        End Try
        Dim delimStr As String = ","
        Dim delimiter() As Char = delimStr.ToCharArray
        Dim strData() As String
        Dim strLine As String
        logdat_num = 0
        DataLogSet.DataTable1.Clear()
        Using reader As New StreamReader(logPath, System.Text.Encoding.Default)
            While (reader.Peek() >= 0)
                strLine = reader.ReadLine()
                strData = strLine.Split(delimiter)
                year_dat(logdat_num) = strData(0)
                month_dat(logdat_num) = strData(1)
                day_dat(logdat_num) = strData(2)
                hour_dat(logdat_num) = strData(3)
                min_dat(logdat_num) = strData(4)
                temp_dat(logdat_num) = Single.Parse(strData(5))
                hr_dat(logdat_num) = Single.Parse(strData(6))
                If logdat_num < logbufMAXKensuu Then
                    DataLogSet.DataTable1.AddDataTable1Row(strData(0), strData(1), strData(2), strData(3), strData(4), strData(5), strData(6))
                    logdat_num = logdat_num + 1
                End If
            End While
            reader.Close()
        End Using
        '
        Using reader As New StreamReader(logPath, System.Text.Encoding.Default)
            TextBox1.Text = reader.ReadToEnd
            reader.Close()
        End Using
        ToolStripStatusLabel1.Text = ""
    End Sub

    Private Sub mnuFileJoin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileJoin.Click
        FileJoin()
    End Sub

    Private Sub mnuFileDisJoin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileDisJoin.Click
        FileDisJoin()
    End Sub

    Private Sub mnuFileNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileNew.Click
        FileNew()
    End Sub

    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        FileOpen()
    End Sub

    Private Sub mnuFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSave.Click
        FileSave()
    End Sub

    Private Sub mnuFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSaveAs.Click
        FileSaveAs()
    End Sub

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        FileExit()
        Me.Close()
    End Sub

    Private Sub mnuEditCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditCopy.Click
        EditCopy()
    End Sub

    Private Sub mnuEditSelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditSelectAll.Click
        EditSelectAll()
    End Sub

    Private Sub mnuToolLogRead1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuToolLogRead1.Click
        ToolLogRead1()
    End Sub

    Private Sub mnuToolLogRead2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuToolLogRead2.Click
        ToolLogRead2()
    End Sub

    Private Sub mnuToolLogRead3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuToolLogRead3.Click
        ToolLogRead3()
    End Sub

    Private Sub mnuToolEEPROMErase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuToolEEPROMErase.Click
        ToolEEPROMErase()
    End Sub

    Private Sub mnuToolThermoHygroTrend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuToolThermoHygroTrend.Click
        ToolThermoHygroTrend()
    End Sub

    Private Sub mnuToolSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuToolSet.Click
        ToolSet()
    End Sub

    Private Sub mnuHelpIndex_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpIndex.Click
        HelpIndex()
    End Sub

    Private Sub mnuHelpAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpAbout.Click
        HelpAbout()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        FileExit()
    End Sub

    Private Sub FileJoin()
        If ComPort = -1 Then
            Dim result As DialogResult
            result = MessageBox.Show("COMポートを設定してください。", "接続", MessageBoxButtons.OK)
            Return
        End If
        '通信設定
        Select Case ComPort
            Case 0
                SerialPort1.PortName = "COM1"
            Case 1
                SerialPort1.PortName = "COM2"
            Case 2
                SerialPort1.PortName = "COM3"
            Case 3
                SerialPort1.PortName = "COM4"
            Case 4
                SerialPort1.PortName = "COM5"
            Case 5
                SerialPort1.PortName = "COM6"
            Case 6
                SerialPort1.PortName = "COM7"
            Case 7
                SerialPort1.PortName = "COM8"
            Case 8
                SerialPort1.PortName = "COM9"
            Case 9
                SerialPort1.PortName = "COM10"
            Case 10
                SerialPort1.PortName = "COM11"
            Case 11
                SerialPort1.PortName = "COM12"
            Case 12
                SerialPort1.PortName = "COM13"
            Case 13
                SerialPort1.PortName = "COM14"
            Case 14
                SerialPort1.PortName = "COM15"
            Case 15
                SerialPort1.PortName = "COM16"
            Case 16
                SerialPort1.PortName = "COM17"
            Case 17
                SerialPort1.PortName = "COM18"
            Case 18
                SerialPort1.PortName = "COM19"
            Case 19
                SerialPort1.PortName = "COM20"
        End Select
        nlReceive = Chr(13)
        nlTransmit = Chr(13)
        'COMポートオープン
        Err.Clear()
        Try
            SerialPort1.Open()
            SerialPort1.DiscardInBuffer()
            SerialPort1.Write("JOIN" & nlTransmit)
            mnuFileJoin.Enabled = False
            mnuToolLogRead1.Enabled = True
            mnuToolLogRead2.Enabled = True
            mnuToolLogRead3.Enabled = True
            mnuToolEEPROMErase.Enabled = True
            mnuToolThermoHygroTrend.Enabled = True
            ToolStripStatusLabel1.Text = "接続中"
        Catch ex As Exception
            SerialPort1.Close()
            MessageBox.Show("COMポートがオープンできません。", "注意", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            mnuFileJoin.Enabled = True
            mnuToolLogRead1.Enabled = False
            mnuToolLogRead2.Enabled = False
            mnuToolLogRead3.Enabled = False
            mnuToolEEPROMErase.Enabled = False
            mnuToolThermoHygroTrend.Enabled = True
            ToolStripStatusLabel1.Text = ""
            Return
        End Try
    End Sub

    Private Sub FileDisJoin()
        SerialPort1.Close()
        mnuFileJoin.Enabled = True
        mnuToolLogRead1.Enabled = False
        mnuToolLogRead2.Enabled = False
        mnuToolLogRead3.Enabled = False
        mnuToolEEPROMErase.Enabled = False
        mnuToolThermoHygroTrend.Enabled = True
        ToolStripStatusLabel1.Text = ""
    End Sub

    Private Sub FileNew()
        If TextBox1.Text <> "" Then
            Dim result As DialogResult
            Dim i As Integer
            result = MessageBox.Show("ログを消去します。よろしいですか?", "新規", MessageBoxButtons.YesNo)
            If result <> Windows.Forms.DialogResult.Yes Then Return
            For i = 0 To logdat_num
                year_dat(i) = 0
                month_dat(i) = 0
                day_dat(i) = 0
                hour_dat(i) = 0
                min_dat(i) = 0
                temp_dat(i) = 0
                hr_dat(i) = 0
            Next
            logdat_num = 0
            TextBox1.Text = ""
            DataLogSet.DataTable1.Clear()
            Me.Text = title & " : " & newFileName
        End If
    End Sub

    Private Sub FileOpen()
        Dim title_Work As String
        title_Work = ""
        Dim result As DialogResult
        If TextBox1.Text <> "" Then
            result = MessageBox.Show("ログを保存せずに閉じますか?", "データログ温湿度計用連携ツール", MessageBoxButtons.YesNo)
            If result <> Windows.Forms.DialogResult.Yes Then
                Return
            End If
        End If
        OpenFileDialog1.Filter = fileFilter
        'ファイル名初期化-----------------------------------
        If OpenFileDialog1.FileName = "OpenFileDialog1" Then
            OpenFileDialog1.FileName = ""
        End If
        '---------------------------------------------------
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            currentFileName = OpenFileDialog1.FileName
            For i = 0 To logdat_num
                year_dat(i) = 0
                month_dat(i) = 0
                day_dat(i) = 0
                hour_dat(i) = 0
                min_dat(i) = 0
                temp_dat(i) = 0
                hr_dat(i) = 0
            Next
            logdat_num = 0
            TextBox1.Text = ""
            DataLogSet.DataTable1.Clear()
            '
            Dim delimStr As String = ","
            Dim delimiter() As Char = delimStr.ToCharArray
            Dim strData() As String
            Dim strLine As String
            logdat_num = 0
            Using reader As New StreamReader(OpenFileDialog1.FileName, System.Text.Encoding.Default)
                While (reader.Peek() >= 0)
                    strLine = reader.ReadLine()
                    strData = strLine.Split(delimiter)
                    year_dat(logdat_num) = strData(0)
                    month_dat(logdat_num) = strData(1)
                    day_dat(logdat_num) = strData(2)
                    hour_dat(logdat_num) = strData(3)
                    min_dat(logdat_num) = strData(4)
                    temp_dat(logdat_num) = Single.Parse(strData(5))
                    hr_dat(logdat_num) = Single.Parse(strData(6))
                    If logdat_num < logbufMAXKensuu Then
                        DataLogSet.DataTable1.AddDataTable1Row(strData(0), strData(1), strData(2), strData(3), strData(4), strData(5), strData(6))
                        logdat_num = logdat_num + 1
                    End If
                End While
                reader.Close()
            End Using
            '
            Using reader As New StreamReader(OpenFileDialog1.FileName, System.Text.Encoding.Default)
                TextBox1.Text = reader.ReadToEnd
                reader.Close()
            End Using
            '
            Me.Text = title & " : " & My.Computer.FileSystem.GetFileInfo(currentFileName).Name & title_Work
            FileName = My.Computer.FileSystem.GetFileInfo(currentFileName).Name
            OpenFileDialog1.FileName = FileName
            OpenFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(currentFileName).DirectoryName
            SaveFileDialog1.FileName = FileName
            SaveFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(currentFileName).DirectoryName
        End If
    End Sub

    Private Sub FileSave()
        Dim title_Work As String
        title_Work = ""
        If FileName = newFileName Then
            FileSaveAs()
            Return
        End If
        '
        If TextBox1.Text <> "" Then
            Using writer As New StreamWriter(currentFileName, False, System.Text.Encoding.Default)
                writer.Write(TextBox1.Text)
                writer.Close()
                Me.Text = title & " : " & My.Computer.FileSystem.GetFileInfo(currentFileName).Name & title_Work
            End Using
        End If
    End Sub

    Private Sub FileSaveAs()
        Dim title_Work As String
        title_Work = ""
        SaveFileDialog1.FileName = FileName
        SaveFileDialog1.OverwritePrompt = False
        SaveFileDialog1.Filter = fileFilter
        If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            If File.Exists(SaveFileDialog1.FileName) Then
                Dim result As DialogResult
                result = MessageBox.Show("同じ名前のファイルがあります。上書きしますか?", "ファイルの新規作成", MessageBoxButtons.YesNo)
                If result <> Windows.Forms.DialogResult.Yes Then Return
            End If
            '
            If TextBox1.Text <> "" Then
                Using writer As New StreamWriter(SaveFileDialog1.FileName, False, System.Text.Encoding.Default)
                    writer.Write(TextBox1.Text)
                    writer.Close()
                    currentFileName = SaveFileDialog1.FileName
                    Me.Text = title & " : " & My.Computer.FileSystem.GetFileInfo(currentFileName).Name & title_Work
                    FileName = My.Computer.FileSystem.GetFileInfo(currentFileName).Name
                    OpenFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(currentFileName).DirectoryName
                    SaveFileDialog1.FileName = FileName
                    SaveFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(currentFileName).DirectoryName
                End Using
            End If
        End If
    End Sub

    Private Sub FileExit()
        Using writer As New StreamWriter(logPath, False, System.Text.Encoding.Default)
            writer.Write(TextBox1.Text)
            writer.Close()
        End Using
    End Sub

    Private Sub EditCopy()
        Clipboard.SetDataObject(DataGridView1.GetClipboardContent())
    End Sub

    Private Sub EditSelectAll()
        DataGridView1.SelectAll()
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        '通信処理(受信)
        Dim year, month, day, hour, min, temp_ndp, temp_dp, hr_ndp, hr_dp As Integer
        Dim temp, hr As Single
        Dim read_num, read_numWork, i0, i1, i2, i3, i4, i5, i6, i7 As Integer
        Dim Readbuf(8) As Byte
        read_numWork = SerialPort1.BytesToRead \ 8
        On Error Resume Next
        If Me.CtrRead = True Then
            For read_num = 1 To read_numWork
                Me.TerminalError = False
                SerialPort1.Read(Readbuf, 0, 8)       'シリアル ポートバイト受信
                i0 = Readbuf(0)
                i1 = Readbuf(1)
                i2 = Readbuf(2)
                i3 = Readbuf(3)
                i4 = Readbuf(4)
                i5 = Readbuf(5)
                i6 = Readbuf(6)
                i7 = Readbuf(7)
                Me.DataKensuu = i3 * 256 + i2
            Next
            read_numWork = 0
            Me.CtrRead = False
        End If
        '
        For read_num = 1 To read_numWork
            Me.TerminalError = False
            SerialPort1.Read(Readbuf, 0, 8)       'シリアル ポートバイト受信
            year = Readbuf(0)
            year = year + 2000
            month = Readbuf(1)
            day = Readbuf(2)
            hour = Readbuf(3)
            min = Readbuf(4)
            temp_ndp = Readbuf(5)
            hr_ndp = Readbuf(6)
            temp_dp = Readbuf(7) \ 16
            hr_dp = Readbuf(7) Mod 16
            If (temp_ndp \ 128 = 0) Then
                temp = Single.Parse(temp_ndp & "." & temp_dp)
            Else
                temp = Single.Parse((temp_ndp Mod 128) & "." & temp_dp) * -1
            End If
            hr = Single.Parse(hr_ndp & "." & hr_dp)
            Me.year_dat(logdat_num) = year
            Me.month_dat(logdat_num) = month
            Me.day_dat(logdat_num) = day
            Me.hour_dat(logdat_num) = hour
            Me.min_dat(logdat_num) = min
            Me.temp_dat(logdat_num) = temp
            Me.hr_dat(logdat_num) = hr
            Me.DataReceiveKonkai = Me.DataReceiveKonkai + 1
            Me.logdat_num = Me.logdat_num + 1
            Me.ToolStripStatusLabel2.Text = "読み込み件数：" & Me.DataReceiveKonkai.ToString & ""
        Next
    End Sub

    Private Sub DispRenew_Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DispRenew_Timer1.Tick

        If DataReceiveZenkai = DataReceiveKonkai Then

            Dim line_edit, line_editbuff As String
            line_editbuff = ""

            Dim i As Integer

            For i = logdat_num_dispbak To logdat_num - 1
                If logdat_num < logbufMAXKensuu Then
                    DataLogSet.DataTable1.AddDataTable1Row(year_dat(i), month_dat(i), day_dat(i), hour_dat(i), min_dat(i), temp_dat(i), hr_dat(i))

                    line_edit = year_dat(i) & "," & month_dat(i) & "," & day_dat(i) & "," & hour_dat(i) & "," & min_dat(i) & "," & temp_dat(i) & "," & hr_dat(i)
                    line_editbuff = line_editbuff & line_edit & Chr(13) & Chr(10)

                End If
            Next

            Me.TextBox1.Text = Me.TextBox1.Text & line_editbuff

            DispRenew_Timer1.Enabled = False
            ToolStripStatusLabel2.Text = ""
            ReceiveItemEnable()
        Else
            DataReceiveZenkai = DataReceiveKonkai
        End If
    End Sub

    Private Sub ToolLogRead1()
        SerialPort1.DiscardInBuffer()
        DataReceiveZenkai = 0
        DataReceiveKonkai = 0
        logdat_num_dispbak = logdat_num
        DispRenew_Timer1.Enabled = True
        Try
            ReceiveItemDisable()
            TerminalError = True
            SerialPort1.Write("SAR1" & nlTransmit)
            ToolLogRead1_Timer1.Enabled = True
        Catch ex As Exception
            ReceiveItemEnable()
            Return
        End Try
    End Sub

    Private Sub ToolLogRead1_Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolLogRead1_Timer1.Tick
        ToolLogRead1_Timer1.Enabled = False
        Dim result As DialogResult
        If TerminalError = True Then
            TerminalError = False
            ToolStripStatusLabel2.Text = ""
            result = MessageBox.Show("通信エラー", "データ読み込み(過去1日)", MessageBoxButtons.OK)
            If result <> Windows.Forms.DialogResult.OK Then
                ReceiveItemEnable()
                Return
            End If
        End If
    End Sub

    Private Sub ToolLogRead2()
        SerialPort1.DiscardInBuffer()
        DataReceiveZenkai = 0
        DataReceiveKonkai = 0
        logdat_num_dispbak = logdat_num
        DispRenew_Timer1.Enabled = True
        Try
            ReceiveItemDisable()
            TerminalError = True
            SerialPort1.Write("SAR2" & nlTransmit)
            ToolLogRead2_Timer1.Enabled = True
        Catch ex As Exception
            ReceiveItemEnable()
            Return
        End Try
    End Sub

    Private Sub ToolLogRead2_Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolLogRead2_Timer1.Tick
        ToolLogRead2_Timer1.Enabled = False
        Dim result As DialogResult
        If TerminalError = True Then
            TerminalError = False
            ToolStripStatusLabel2.Text = ""
            result = MessageBox.Show("通信エラー", "データ読み込み(過去7日)", MessageBoxButtons.OK)
            If result <> Windows.Forms.DialogResult.OK Then
                ReceiveItemEnable()
                Return
            End If
        End If
    End Sub

    Private Sub ToolLogRead3()
        SerialPort1.DiscardInBuffer()
        DataReceiveZenkai = 0
        DataReceiveKonkai = 0
        logdat_num_dispbak = logdat_num
        DispRenew_Timer1.Enabled = True
        Try
            ReceiveItemDisable()
            TerminalError = True
            SerialPort1.Write("SAR3" & nlTransmit)
            ToolLogRead3_Timer1.Enabled = True
        Catch ex As Exception
            ReceiveItemEnable()
            Return
        End Try
    End Sub

    Private Sub ToolLogRead3_Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolLogRead3_Timer1.Tick
        ToolLogRead3_Timer1.Enabled = False
        Dim result As DialogResult
        If TerminalError = True Then
            TerminalError = False
            ToolStripStatusLabel2.Text = ""
            result = MessageBox.Show("通信エラー", "データ読み込み(全件)", MessageBoxButtons.OK)
            If result <> Windows.Forms.DialogResult.OK Then
                ReceiveItemEnable()
                Return
            End If
        End If
    End Sub

    Private Sub ToolEEPROMErase()
        Dim result As DialogResult
        result = MessageBox.Show("EEPROM内のログデータは完全に消去されます。よろしいですか？" & Chr(13) & Chr(10) & "※EEPROM データ消去中は、データログ温湿度計のLCDパネルに" & Chr(13) & Chr(10) & "｢ EEPROM ERASE!! ｣のメッセージが表示されます。", "EEPROM データ完全消去", MessageBoxButtons.YesNo)
        If result = Windows.Forms.DialogResult.No Then Return
        SerialPort1.DiscardInBuffer()
        TextBox1.Text = ""
        Try
            SerialPort1.Write("ERASE" & nlTransmit)
        Catch ex As Exception
            Return
        End Try
    End Sub

    Private Sub ToolThermoHygroTrend()
        Dim ThermoHygroTrendform As ThermohygrologgerTrend = New ThermohygrologgerTrend()
        ThermoHygroTrendform.ShowDialog()
    End Sub

    Private Sub ToolSet()
        ThermohygrologgerSet.ShowDialog()
        If ThermohygrologgerSet.DialogResult = Windows.Forms.DialogResult.OK Then
            DataFileWrite()     'DATAファイルの書き込み
        End If
    End Sub

    Private Sub HelpIndex()
        Try
            Help.ShowHelp(Me, helpFileName)
        Catch ex As Exception
            MessageBox.Show("ヘルプファイルが見つかりません")
        End Try
    End Sub

    Private Sub HelpAbout()
        Dim aboutform As About = New About()
        aboutform.ShowDialog()
    End Sub

    Private Sub DataFileWrite()
        'DATAファイルの書き込み
        Dim num01 As Integer
        Using writer As New StreamWriter(datPath, False, System.Text.Encoding.Default)
            For num01 = 0 To 1
                writer.WriteLine(dat(num01))
            Next
        End Using
    End Sub

    Private Sub ReceiveItemEnable()
        mnuToolLogRead1.Enabled = True
        mnuToolLogRead2.Enabled = True
        mnuToolLogRead3.Enabled = True
        mnuToolEEPROMErase.Enabled = True
        mnuToolThermoHygroTrend.Enabled = True
    End Sub

    Private Sub ReceiveItemDisable()
        mnuToolLogRead1.Enabled = False
        mnuToolLogRead2.Enabled = False
        mnuToolLogRead3.Enabled = False
        mnuToolEEPROMErase.Enabled = False
        mnuToolThermoHygroTrend.Enabled = False
    End Sub
End Class
